#!/usr/bin/python

'''
   File name: curly.py
   Author: Wayne Parham
   Date created: 12/12/2018
'''

import os, shlex, subprocess, sys

user = "user:password"
endpoint = "http://endpoint.com/api/service"
org = "org"
project = "project"
repo = "repo" 
entrypoint = "reportToJIRA"
cURLcmd = "curl -u "+user+" "+endpoint+" -v -F org="+org+" -F project="+project+" -F repo="+repo+" -F entryPoint="+entrypoint+" -F request="

argv = sys.argv
if( len( argv ) != 2 ):
   print( "usage: curly.py <filename>" )
   sys.exit()
else:
   filename = argv[1]

retval = 0

try:
   quote = '"'
   datafile = open( filename, "rb" )
   message = datafile.read()
   datafile.close()
   jira_msg = "{\n  " + quote + "arguments" + quote + ":\n" + message + "}\n"
   jirafile = open( "jira.dat", "wb" )
   jirafile.write( jira_msg )
   jirafile.close()
   command = cURLcmd + "@jira.dat"
   print( command )
   args = shlex.split( command )
   try:
      if( sys.version_info[0] < 3 ):
         proc = subprocess.Popen( command, shell=True,
                                  universal_newlines=True,
                                  stdout=subprocess.PIPE,
                                  stderr=subprocess.PIPE )
      else:
         proc = subprocess.Popen( args, shell=True,
                                  universal_newlines=True,
                                  stdout=subprocess.PIPE,
                                  stderr=subprocess.PIPE )
      (output, err) = proc.communicate()
      retval = proc.wait()
      print( output + err )
      if "< HTTP/1.1 400 Bad Request" in err:
         print( "==> ERROR: Bad data in cURL request." )
         retval = -1
      elif "couldn't connect to host" in err:
         print( "==> ERROR: Can't connect to host." )
         retval = -1
   except OSError:
      print( "==> ERROR: Invalid cURL command." )
      retval = -1
   finally:
      os.remove( "jira.dat" )
except OSError:
   print( "==> ERROR: couldn't open " + filename + " for reading." )
   retval = -1
if( retval == 0 ):
   print( "==> Sent report to " + endpoint + "." )

